---
title: MediaStream Image Capture API
slug: Web/API/MediaStream_Image_Capture_API
tags:
  - API
  - Image
  - MediaStream
  - MediaStream Image Capture API
  - Overview
  - Reference
  - Video
---
<p>{{DefaultAPISidebar("Image Capture API")}}{{SeeCompatTable}}</p>

<p class="summary">The <strong>MediaStream Image Capture API</strong> is an API for capturing images or videos from a photographic device. In addition to capturing data, it also allows you to retrieve information about device capabilities such as image size, red-eye reduction and whether or not there is a flash and what they are currently set to. Conversely, the API allows the capabilities to be configured within the constraints what the device allows.</p>

<h2 id="MediaStream_image_capture_concepts_and_usage">MediaStream image capture concepts and usage</h2>

<p>The process of retrieving an image or video stream happens as described below. The example code is adapted from <a href="https://googlechrome.github.io/samples/image-capture/">Chrome's Image Capture examples</a>.</p>

<p>First, get a reference to a device by calling {{domxref("MediaDevices.getUserMedia()")}}. The example below says give me whatever video device is available, though the <code>getUserMedia()</code> method allows more specific capabilities to be requested. This method returns a {{jsxref("Promise")}} that resolves with a {{domxref("MediaStream")}} object.</p>

<pre class="brush: js notranslate">navigator.mediaDevices.getUserMedia({ video: true })
  .then(mediaStream =&gt; {
    // Do something with the stream.
  })
</pre>

<p id="sect1">Next, isolate the visual part of the media stream. Do this by calling {{domxref("MediaStream.getVideoTracks()")}}. This returns an array of {{domxref("MediaStreamTrack")}} objects. The code below assumes that the first item in the <code>MediaStreamTrack</code> array is the one to use. You can use the properties of the <code>MediaStreamTrack</code> objects to select the one you need.</p>

<pre class="brush: js notranslate">const track = mediaStream.getVideoTracks()[0];</pre>

<p>At this point, you might want to configure the device capabilities before capturing an image. You can do this by calling {{domxref("MediaStreamTrack.applyConstraints","applyConstraints()")}} on the track object before doing anything else.</p>

<pre class="brush: js notranslate">let zoom = document.querySelector('#zoom');
const capabilities = track.getCapabilities();
// Check whether zoom is supported or not.
if(!capabilities.zoom) {
  return;
}
track.applyConstraints({ advanced : [{ zoom: zoom.value }] });
</pre>

<p>Finally, pass the <code>MediaStreamTrack</code> object to the {{domxref("ImageCapture.ImageCapture()", "ImageCapture()")}} constructor. Though a <code>MediaStream</code> holds several types of tracks and provides multiple methods for retrieving them, the ImageCapture constructor will throw a {{domxref("DOMException")}} of type <code>NotSupportedError</code> if {{domxref("MediaStreamTrack.kind")}} is not <code>"video"</code>.</p>

<pre class="brush: js notranslate">let imageCapture = new ImageCapture(track);
</pre>

<h2 id="Interfaces">Interfaces</h2>

<dl>
 <dt>{{domxref("ImageCapture")}}</dt>
 <dd>An interface for capturing images from a photographic device referenced through a valid {{domxref("MediaStreamTrack")}}.</dd>
 <dt>{{domxref("PhotoCapabilities")}}</dt>
 <dd>Provides available configuration options for an attached photographic device. Retrieve a <code>PhotoCapabilities</code> object by calling {{domxref("ImageCapture.getPhotoCapabilities()")}}.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('MediaStream Image')}}</td>
   <td>{{Spec2('MediaStream Image')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<h3 id="ImageCapture"><code>ImageCapture</code></h3>

<p>{{Compat("api.ImageCapture")}}</p>

<h3 id="PhotoCapabilities"><code>PhotoCapabilities</code></h3>

<div class="hidden">The compatibility table on this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</div>

<p>{{Compat("api.PhotoCapabilities")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("MediaStream")}}</li>
 <li>{{domxref("MediaStreamTrack")}}</li>
</ul>
